package com.mamezou.jms.converter;

import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.Session;

import org.springframework.jms.support.converter.MessageConversionException;
import org.springframework.jms.support.converter.MessageConverter;

public class OrderMessageConverter implements MessageConverter {

    public Message toMessage(Object object, Session session)
            throws JMSException, MessageConversionException {
        Order order = (Order) object;
        Message ret = session.createMessage();
        ret.setObjectProperty("productId", new Integer(order.getProductId()));
        ret.setObjectProperty("quantity", new Integer(order.getQuantity()));
        ret.setObjectProperty("message", order.getComment());
        return ret;
    }

    public Object fromMessage(Message message) throws JMSException,
            MessageConversionException {
        Integer id = (Integer) message.getObjectProperty("productId");
        Integer quantity = (Integer) message.getObjectProperty("quantity");
        String msg = (String) message.getObjectProperty("message");
        return new Order(id.intValue(), quantity.intValue(), msg);
    }
}
