package com.mamezou.jms.withoutspring;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.Message;
import javax.jms.MessageConsumer;
import javax.jms.MessageListener;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class MdpJmsTopicSubscriber {
    private MdpJmsTopicSubscriber() {
        Context context;
        ConnectionFactory factory = null;
        Connection conn = null;
        Session session = null;
        
        try {
            context = new InitialContext();
            factory = (ConnectionFactory) context.lookup("ConnectionFactory");
            conn = factory.createConnection();
            session = conn.createSession(false, Session.AUTO_ACKNOWLEDGE);
            Destination topic = session.createTopic("mytopic");
            

            MessageListener listener = new MessageListener() {

                public void onMessage(Message message) {
                    TextMessage m = (TextMessage) message;
                    try {
                        System.out.println(m.getText());
                    } catch (JMSException e) {
                        e.printStackTrace();
                    }
                }
                
            };
            
            
            MessageConsumer consumer = session.createConsumer(topic);
            consumer.setMessageListener(listener);
            conn.start();
            
            while (true) {
                Thread.sleep(1000);
            }
        } catch (NamingException e) {
            e.printStackTrace();
        } catch (JMSException e) {
            e.printStackTrace();
        } catch (InterruptedException e) {
            e.printStackTrace();
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (JMSException e) {
                }
            }
            
            if (conn != null) {
                try {
                    conn.close();
                } catch (JMSException e) {
                }
            }
        }
    }
    
    public static void main(String[] args) {
        new MdpJmsTopicSubscriber();
    }
}
