package com.mamezou.jms.withoutspring;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.MessageConsumer;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

public class SimpleJmsTopicSubscriber {
    private SimpleJmsTopicSubscriber() {
        Context context;
        ConnectionFactory factory = null;
        Connection conn = null;
        Session session = null;
        
        try {
            context = new InitialContext();
            factory = (ConnectionFactory) context.lookup("ConnectionFactory");
            conn = factory.createConnection();
            session = conn.createSession(false, Session.AUTO_ACKNOWLEDGE);
            Destination topic = session.createTopic("mytopic");
            

            MessageConsumer consumer = session.createConsumer(topic);
            conn.start();
            TextMessage m = (TextMessage) consumer.receive();
            System.out.println("message = " + m.getText());

        } catch (NamingException e) {
            e.printStackTrace();
        } catch (JMSException e) {
            e.printStackTrace();
        } finally {
            if (session != null) {
                try {
                    session.close();
                } catch (JMSException e) {
                }
            }
            
            if (conn != null) {
                try {
                    conn.close();
                } catch (JMSException e) {
                }
            }
        }
    }
    
    public static void main(String[] args) {
        new SimpleJmsTopicSubscriber();
    }
}
